
/***************************************************************************
 *            main.cxx
 *
 *  Fri Sep 21 15:05:23 2007
 *  Copyright  2007  chekanov
 *  chekanov@mail.desy.de
 ****************************************************************************/



#include<iostream>
#include<fstream>
#include<stdlib.h>
#include<stdio.h>
#include "LParticle.h"
#include "CParticle.h"
#include<vector>

using namespace std;

//statshapes() calculates & returns regression-based variables
extern double* statshapes(LParticle);

//split() splits data string from "testjets.txt" into substrings
extern vector<string> split(const string& s, const string& delim, const bool keep_empty);

//pull() calculates & returns 'pull' value & moments
extern double* pull(LParticle);

//width() calculates & returns PCA jet width
extern double Width(LParticle);

//eccentricity() calculates & returns PCA eccentricity
extern double eccentricity(LParticle);

int main(int argc, char **argv)
{
	int n=0;
        int nev=0;
	ifstream input("testjets.txt");
        string str;
	string str1;
        while (getline(input,str)){
		int j=0;
		double line[5];
                vector<string> splitline = split(str," ",false);
		if (splitline.size() == 5){
			const char* cp[5];
			for (int i=0; i<4; i++){
				cp[i] = splitline[i].c_str();
				line[i] = strtod(cp[i],NULL);
			} 
			cp[4] = splitline[4].c_str(); 
			line[4] = atoi(cp[4]);	
						
   			// create LParticle (jet)
			LParticle p(line[0],line[1],line[2],line[3],0);

                        
			while (getline(input,str1)){
			if (j >= line[4]+1) break;
			if (j < line[4]+1){
				j++;
				vector<string> splitline1 = split(str1," ",false);
				int constit[4];
				const char* cpconstit[4];
				if (splitline1.size() == 4){
					for (int i=0; i<4; i++){
						cpconstit[i] = splitline1[i].c_str();
						constit[i] = atoi(cpconstit[i]);
					}
					CParticle con(constit[0],constit[1],constit[2],0,0,constit[3]);
					p.SetConstituent(con);
				}
			}
			}	
			double* summary = statshapes(p);
			double* T = pull(p);
			double ecc = eccentricity (p);
			double jet_width = Width(p);
			if (T != T) n++;
	
			cout<<"Event:  "<<nev<<endl;
			cout<<"Eccentricity(q)="<<summary[2]<<"   major_Eccentricity(q)="<<summary[5]<<"    minor_Eccentricity(q)="<<summary[8]<<endl;
			cout<<"Eccentricity(nq)="<<summary[16]<<"   major_Eccentricity(nq)="<<summary[20]<<"   minor_Eccentricity(nq)="<<summary[21]<<endl;
			cout<<"Pull ="<<T[0]<<"   theta="<<T[1]<<"pi   PullMoments="<<T[2]<<" "<<T[3]<<" "<<T[4]<<" "<<T[5]<<"   JetWidth="<<jet_width<<"   pcaECC="<<ecc<<endl;
			nev++;


		}
	}
return 0;
}


